#!/bin/bash


#     /var/cache/apt/archives/
#   ,    Master2.2+updates
#   ,     Sisyphus.
#          ()
# .
#        apt
#
# Requries:
#
# 	genbasedir 	(apt-utils)
# 	diff		(diffutils)
#	sort,mkdir	(coreutils)
#
#------ configuration -------

#    cache apt-get
APTARCH_DIR="/var/cache/apt/archives"

#      ALM2.2+updates
ALMUPDLIST="alm_updates.ls" 
#
# alm_updates.ls  :
#
# unalias ls 
# ls <dir____RPM__ALM>/*.rpm  > master.ls
# ls <dir____RPM_updates>/*.rpm > updates.ls
# cat master.ls updates.ls |sort > alm_updates.ls
#

#     /var/cache/apt
APTCACHELIST="aptcache.ls.tmp"			

#     /var/cache/apt,   ALM+updates.  
SISYPHUS_TMPLIST="/var/tmp/sisyphus.ls.tmp"	

#   /var/cache/apt,   ALM+updates. 
#       .
# .
APTCACHE_WIHTOUT_SISYPHUS="aptcache_wo_sisyphus.ls.tmp"

SISYPHUS_DIR="/var/tmp/sisyphus-from-aptcache" #    
#!             /var/cache/apt
#

#---- end configuration ----

#     
echo "Make directory structure for new repository"
mkdir -p $SISYPHUS_DIR/i586/RPMS.sisyphus $SISYPHUS_DIR/i586/base $SISYPHUS_DIR/SRPMS.sisyphus 

echo "Copy aptcache packages to new place"
cat /dev/null > $APTCACHELIST.1

find $APTARCH_DIR -name "*.rpm" | while read i;
	do 
		RPMNAME=`rpm -qp --queryformat "%{NAME}-%{VERSION}-%{RELEASE}.%{ARCH}.rpm" $i` 
		cp $i $SISYPHUS_DIR/i586/RPMS.sisyphus/$RPMNAME
		echo $RPMNAME >>$APTCACHELIST.1
	done
echo -e "Copy complete\n"

echo -e "\n Making list of packages from aptcache..."
cat $APTCACHELIST.1 |sort >$APTCACHELIST
diff -U0 $ALMUPDLIST $APTCACHELIST |grep "^+"|grep -v "^++"|sed "s/^+//"> $SISYPHUS_TMPLIST
rm -f $APTCACHELIST.1
echo -e "aptcache packages list done.\n"


echo "Making list of files to remove"
diff -U0 $APTCACHELIST $SISYPHUS_TMPLIST |grep "^-"|grep -v "^--"|sed "s/^-//"> $SISYPHUS_DIR/i586/RPMS.sisyphus/$APTCACHE_WIHTOUT_SISYPHUS

echo "Entering to new place ($SISYPHUS_DIR/i586/RPMS.sisyphus/)"
cd $SISYPHUS_DIR/i586/RPMS.sisyphus/
echo "Remove files belong alm_updates.ls"
rm -f `cat $APTCACHE_WIHTOUT_SISYPHUS`
echo -e "Old files removed\n"

echo "Making new apt repository..."
genbasedir --topdir $SISYPHUS_DIR i586 sisyphus
echo "New repository in $SISYPHUS_DIR complete"

